// funktsioon printf

#include <stdio.h>	// stdio.h sisaldab funktsiooni printf kirjelduse
			// description of function printf is in stdio.h
int main(void)
{
	int i;			// tisarv - integer
	float f; 		// murdarv - floating point
	char c;			// mrk - character
	const char n='\n';      // reavahetus - new line

// funktsiooni printf parameetriteks on vorming (formaat) ja muutujate loend
// parameters of printf are format string and list of variables
//	printf("format", var1, var2, ...);
// igale muutujale on vormingus vorminguelement, mis algab %-mrgiga
// for every variable is in format item, which begins with character %
		// VORMINGUELEMENDID - FORMAT ITEMS
// mrgid - characters - %c
	c='A';
	printf("c=%c%c",c,n);
// tisarvud - integers - %d, %nd, %-nd
		// n - vljundvlja laius - width
		// miinusmrk - joondamine vasakule
		// minus sign - left alignment
	i=123;
	printf("i=%d%c",i,n);
	printf("i=%5d%c",i,n);
	printf("i=%-5d,c=%c %c",i,c,n);
// murdarvud - floating point - %n.mf, %-n.mf
		// n - vljundvlja laius - width
		// m - kaks kohta prast koma
		// m - two digits after decimal point
	f=12.34;
	printf("f=%8.3f%c",f,n);
	printf("f=%-10.2f, c=%c%c",f,c,n);
	return 0;
}


