// PROGRAMM NITAB FUNKTSIOONI PARAMEETRITE KAHTE ERINEVAT EDASTUST
// PROGRAM SHOWS DIFFERENCE BETWEEN TWO POSSIBLE WAYS TO USE PARAMETERS

// vrtusparameeter - parameetri vrtuse KOOPIA edastatakse funktsioonile
// by value - the COPY of parameter value is passed to function

// viidaparameeter - parameetri AADRESS edastatakse funktsioonile
// by reference - the ADDRESS of parameter is passed to function

#include <stdio.h>

int main(void)
{
   void noswap(int, int);	// vrtusparameetritega funktsioon
				// parameters passed by value
   void swap(int*, int*);	// viidaparameetritega funktsioon
				// parameters passed by reference
   int first=50, second=10;
   printf("first=%d, second=%d\n", first, second);
   noswap(first, second);
   printf("first=%d, second=%d\n", first, second);
   swap(&first, &second);
   printf("first=%d, second=%d\n", first, second);
   return 0;
}

void noswap(int a, int b)
{
   int temp;
   if (a>b) {temp=a; a=b; b=temp;}
   printf("a=%d, b=%d\n", a, b);
   return;
}

void swap(int* a, int* b)
{
   int temp;
   if (*a>*b) {temp=*a; *a=*b; *b=temp;}
   printf("a=%d, b=%d\n", *a, *b);
   return;
}