// PROGRAMM KSIB KASUTAJA PAROOLI
// PROGRAM ASKS USER PASSWORD

#include <string.h>	// stringifunktsioonide teek
			// library of string functions
#include <conio.h>

class KASUTAJA{
   char *nimi;       	// kasutaja nimi - user's name
   char *parool;	// kasutaja parool - user's password
public:
   KASUTAJA(char*);
   int login(void);    // funktsioon 'login' ksib kasutaja parooli
		       // function 'login' asks user password
};

KASUTAJA::KASUTAJA(char *p)
{
   int l=strlen(p)+1;   // stringi pikkus - length of string
   nimi=new char[l];	// uue stringi loomine - creating new string
   strcpy(nimi,p);	// stringi kopeerimine - copying string
   parool=NULL;
}

int KASUTAJA::login(void)
{
   char *x,*x2;
   int l;
   if(parool==NULL)	// kasutajal pole veel parooli
			// user don't have valid password
      {x=getpass("You have no password, enter password> ");
       l=strlen(x)+1;
       parool=new char[l];
       strcpy(parool,x);
       x=getpass("Enter second time");
			// uut parooli ksitakse kaks korda
			// program asks new password two times
       if(strcmp(parool,x)){	// stringide vrdlemine - comparing strings
	  cprintf("Sorry\n\r");
	  parool=NULL;
	  return 1;
       }
       return 0;
   }
   else {for(int i=0;i<2;i++){	// kasutajal on parool olemas - user has password
	 cprintf("\n\rUser %s, ", nimi);
	 x=getpass("Enter password ");
	 if(!strcmp(x,parool)){cprintf("OK\n\r"); return 0;}
	    else {cprintf("%s\n", i ? "\r\nSorry!": "\r\nWrong!");
	    if (i) return 1;}	// teist korda sisestati vale parool
				// second time wrong password was given
	 }
   }
}

int main(void)
{
   KASUTAJA user("mina");
   clrscr();
   if(user.login())cprintf("Sorry 1\n\r");
   if(user.login()){cprintf("Sorry 2\n\r");return 1;}
   return 0;
}
