// TEHTEMRKIDE LEDEFINEERIMINE - OVERLOADING OPERATORS

#include <string.h>
#include <conio.h>

class TEXT{
   int length;
   char *textpointer;
public:
   TEXT(char*);
   ~TEXT(void) {delete textpointer;} // destruktor - kivitub objekti kustutamisel
		// destructor - executes when object is deleted
   void operator +=(char*); // "operator" annab tehtemrgile uue thenduse
			//  The keyword "operator", followed by an
			// operator symbol, defines a new (overloaded)
			// action of the given operator.
   void print(void) {cprintf("%s\n\r",textpointer);}
};

TEXT::TEXT(char *param)
{
   length=strlen(param);         // tekstistringi pikkus - length of text
   textpointer=new char[length+1];  // mlu eraldamine - memory allocation
   strcpy(textpointer,param);	// tekstistringi koopia - copy of text
}

void TEXT::operator +=(char *add)	// tekstistringide hendamine
					// appending string
{
   char* temp;
   length+=strlen(add);	// uue tekstistringi pikkus - lenght of new string
   temp=new char[length+1];
   strcpy(temp,textpointer);
   delete textpointer;
   strcat(temp, add);
   textpointer=temp;
}


int main(void)
{
   clrscr();
   TEXT t1("Tallinna");
   t1.print();
   char t2[]=" Tehnikalikool";
   t1+=t2;
   t1.print();
   getch();
   return 0;
}


