// UUTE KLASSIDE TULETAMINE - DERIVATION OF OBJECT CLASSES

#include <string.h>
#include <conio.h>

class TEXT{		// objektide klass TEXT - object class TEXT
   int length;
   char *textpointer;
public:
   TEXT(char*);
   ~TEXT(void) {delete textpointer;} // destruktor - kivitub objekti kustutamisel
		// destructor - executes when object is deleted
   void print(void) {cprintf("%s\n\r",textpointer);}
};

TEXT::TEXT(char *param)
{
   length=strlen(param);         // tekstistringi pikkus - length of text
   textpointer=new char[length+1];  // mlu eraldamine - memory allocation
   strcpy(textpointer,param);	// tekstistringi koopia - copy of text
}

class TEXT_ON_SCREEN: TEXT{
   // tuletatud klass - sisaldab kiki klassi TEXT andmeid ja funktsioone
   // derivated class - includes all data and functions from class TEXT
   int x, y;	// lisaks teksti koordinaadid ekraanil
		// ... and also coordinates of text on screen
public:
   TEXT_ON_SCREEN (char *p, int p1, int p2) :TEXT(p) {x=p1; y=p2;}
	// klassi TEXT_ON_SCREEN objekti loomisel tidetakse nii klassi
	// TEXT kui ka TEXT_ON_SCREEN konstruktorid
	// during creation of object of class TEXT_ON_SCREEN
	// both constructors will be executed (TEXT and TEXT_ON_SCREEN)
   void printxy(void) {gotoxy(x,y); print();}
};

int main(void)
{
   clrscr();
   TEXT_ON_SCREEN t1("PROGRAM P34.CPP", 32, 12);
   t1.printxy();
   TEXT_ON_SCREEN t2("Press any key to stop program", 1, 25);
   t2.printxy();
   getch();
   return 0;
}


