// time.h - AJAFUNKTSIOONID - TIME FUNCTIONS

#include <time.h>
#include <stdio.h>
int main(void)
{
	time_t s; // time_t on deklareeritud time_h-s kui pikk tisarv (long)
		  // time_t is declared in time.h as long integer (long)
	tm *t;	// tm is structure declared in time.h:
		// tm in failis time_t kirjeldatud struktuur:
//struct tm {
//  int tm_sec;      /* Seconds */
//  int tm_min;      /* Minutes */
//  int tm_hour;     /* Hour (0--23) */
//  int tm_mday;     /* Day of month (1--31) */
//  int tm_mon;      /* Month (0--11) */
//  int tm_year;     /* Year (calendar year minus 1900) */
//  int tm_wday;     /* Weekday (0--6; Sunday = 0) */
//  int tm_yday;     /* Day of year (0--365) */
//  int tm_isdst;    /* 0 if daylight savings time is not in effect) */
//};

	s=time(NULL);	// funktsioon time parameetriga NULL
		// annab sekundite arvu alates 1. jaanuarist 1970
		// function time with parameter NULL gives
		// number of seconds elapsed from 1. jan 1970
	printf("function time returns %ld seconds\n", s);
	t=localtime(&s); // funktsioon localtime annab
			// struktuuri tm andmeelementidele vrtuse
	printf("Seconds: %d\n", t->tm_sec);
	printf("Minutes: %d\n", t->tm_min);
	printf("Hours: %d\n", t->tm_hour);
	printf("Day of month: %d\n", t->tm_mday);
	printf("Month: %d\n", t->tm_mon);
	printf("Year: %d\n", t->tm_year);
	printf("Weekday: %d\n", t->tm_wday);
	printf("Daylight time: %d\n", t->tm_isdst);
	return 0;
}