// VIIDAD JA AADRESSID - POINTERS AND ADDRESSES

// viitmuutuja vrtuseks on mluvlja (muutuja, konstant, massiiv jne) aadress
// value of pointer is address of memory object (variable, constant, array etc)

#include <stdio.h>

int main(void)
{
   int *p;	// p on viit tsiarvule (sisaldab tisarvu aadressi)
		// viitmuutuja tunnuseks on '*' nime ees deklaratsioonis
		// p is pointer to integer (contains address of integer)
		// pointer has '*' before its name in declaration
   char *pc;	// pc viitab mrgile vi mrgistringi algusele
		// pc points to character or to begin of string
   int a=777;
   char c='B';
   p=&a;	// muutuja 'a' aadress on '&a'
		// address of variable 'a' is '&a'
   pc=&c;
   printf("Variable a is located in memory at address %p and it's value is %d\n",
	p, *p);	// '*p' on vrtus, millele viitab 'p'
		// '*p' is value pointed by 'p'
		// %p on viitmuutuja vorming - %p is format of pointer
   printf("Variable c is located in memory at address %p and it's value is %c\n",
	pc, *pc);
   pc="String";	// Stringikonstandi aadressi omistamine viitmuutujale
		// Assigning address of character string to a pointer
   printf("String is located in memory at address %p and it's value is %s\n",
	pc, pc);
		// Vorming '%s' nuab viita stringile
		// Format '%s' needs pointer to string
   printf("Addresses of pointers p and pc are: %p and %p\n", &p, &pc);
   *p=333;	// omistamine muutujale, millele viitab viitmuutuja
		// assignment to variable pointed by pointer
   printf("Variable a is located in memory at address %p and it's value now is %d\n",
	p, *p);
   p=NULL;	// NULL on thiviit - NULL is empty pointer
   printf ("Value of pointer p is now %p\n", p);
   return 0;
}